<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__scb__spi" kind="group">
    <compoundname>group_scb_spi</compoundname>
    <title>SPI (SCB)</title>
    <innergroup refid="group__group__scb__spi__macros">Macros</innergroup>
    <innergroup refid="group__group__scb__spi__functions">Functions</innergroup>
    <innergroup refid="group__group__scb__spi__data__structures">Data Structures</innergroup>
    <innergroup refid="group__group__scb__spi__enums">Enumerated Types</innergroup>
    <briefdescription>
<para>Driver API for SPI Peripheral. </para>    </briefdescription>
    <detaileddescription>
<para>The functions and other declarations used in this part of the driver are in cy_scb_spi.h. You can also include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>The SPI protocol is a synchronous serial interface protocol. Devices operate in either master or slave mode. The master initiates the data transfer. The SCB supports single-master-multiple-slaves topology for SPI. Multiple slaves are supported with individual slave select lines.</para><para>Features:<itemizedlist>
<listitem><para>Supports master and slave functionalitySupports three types of SPI protocols:<itemizedlist>
<listitem><para>Motorola SPI - modes 0, 1, 2, and 3</para></listitem><listitem><para>Texas Instruments SPI, with coinciding and preceding data frame indicator - mode 1 only</para></listitem><listitem><para>National Semiconductor (MicroWire) SPI - mode 0 only</para></listitem></itemizedlist>
</para></listitem><listitem><para>Master supports up to four slave select lines<itemizedlist>
<listitem><para>Each slave select has configurable active polarity (high or low)</para></listitem><listitem><para>Slave select can be programmed to stay active for a whole transfer, or just for each byte</para></listitem></itemizedlist>
</para></listitem><listitem><para>Master supports late sampling for better timing margin</para></listitem><listitem><para>Master supports continuous SPI clock</para></listitem><listitem><para>Data frame size programmable from 4 bits to 16 bits</para></listitem><listitem><para>Programmable oversampling</para></listitem><listitem><para>MSb or LSb first</para></listitem><listitem><para>Median filter available for inputs</para></listitem></itemizedlist>
</para>
<para><heading level="1">Configuration Considerations</heading></para>
<para>The SPI driver configuration can be divided to number of sequential steps listed below:<itemizedlist>
<listitem><para><ref kindref="member" refid="group__group__scb__spi_1group_scb_spi_config">Configure SPI</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__scb__spi_1group_scb_spi_pins">Assign and Configure Pins</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__scb__spi_1group_scb_spi_clock">Assign Clock Divider</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__scb__spi_1group_scb_spi_data_rate">Configure Data Rate</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__scb__spi_1group_scb_spi_intr">Configure Interrupt</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__scb__spi_1group_scb_spi_enable">Enable SPI</ref></para></listitem></itemizedlist>
</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The SPI driver is built on top of the SCB hardware block. The SCB1 instance is used as an example for all code snippets. Modify the code to match your design.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
<para><bold>Configure SPI</bold></para>
<para>To set up the SPI driver, provide the configuration parameters in the <ref kindref="compound" refid="structcy__stc__scb__spi__config__t">cy_stc_scb_spi_config_t</ref> structure. For example: provide spiMode, subMode, sclkMode, oversample, rxDataWidth, and txDataWidth. The other parameters are optional for operation. To initialize the driver, call <ref kindref="member" refid="group__group__scb__spi__general__functions_1gabe68169c810119b93e1164127663033c">Cy_SCB_SPI_Init</ref> function providing a pointer to the populated <ref kindref="compound" refid="structcy__stc__scb__spi__config__t">cy_stc_scb_spi_config_t</ref> structure and the allocated <ref kindref="compound" refid="structcy__stc__scb__spi__context__t">cy_stc_scb_spi_context_t</ref> structure.</para><para><programlisting><codeline><highlight class="comment">/*<sp />Allocate<sp />context<sp />for<sp />SPI<sp />operation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__scb__spi__context__t">cy_stc_scb_spi_context_t</ref><sp />spiContext;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Populate<sp />configuration<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#if<sp />(USE_SPI_SLAVE)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Slave<sp />configuration<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__scb__spi__config__t">cy_stc_scb_spi_config_t</ref><sp />spiConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__scb__spi__config__t_1a4fc24e3daa02dc8a81de14341a954110">spiMode</ref><sp /><sp />=<sp /><ref kindref="member" refid="group__group__scb__spi__enums_1gga931ca8a003e3da524aadd562945d3ab5a6b016365095f773e900be90867db0976">CY_SCB_SPI_SLAVE</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.subMode<sp /><sp />=<sp /><ref kindref="member" refid="group__group__scb__spi__enums_1gga1410916a9c76b0d86eb196b8e9ed547fa62fab87ba422296db9c490c3b74830ab">CY_SCB_SPI_MOTOROLA</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.sclkMode<sp />=<sp /><ref kindref="member" refid="group__group__scb__spi__enums_1ggab34eae51343cebfec7c447a573cdf0baac7839625f0402b7b9685f3fc2c8a2305">CY_SCB_SPI_CPHA0_CPOL0</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.oversample<sp />=<sp />0UL,<sp /></highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.rxDataWidth<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />8UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.txDataWidth<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />8UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableMsbFirst<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableInputFilter<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableFreeRunSclk<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableMisoLateSample<sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableTransferSeperation<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.ssPolarity<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /><ref kindref="member" refid="group__group__scb__spi__enums_1ggac1d52a37938101b62b908fb4263d98a2ab36d0ae32e47bb37ec614d9bc58b7198">CY_SCB_SPI_ACTIVE_LOW</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableWakeFromSleep<sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.rxFifoTriggerLevel<sp /><sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.rxFifoIntEnableMask<sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.txFifoTriggerLevel<sp /><sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.txFifoIntEnableMask<sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.masterSlaveIntEnableMask<sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Master<sp />configuration<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__scb__spi__config__t">cy_stc_scb_spi_config_t</ref><sp />spiConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__scb__spi__config__t_1a4fc24e3daa02dc8a81de14341a954110">spiMode</ref><sp /><sp />=<sp /><ref kindref="member" refid="group__group__scb__spi__enums_1gga931ca8a003e3da524aadd562945d3ab5aac0d1cba1a96754415d7457a35cf6510">CY_SCB_SPI_MASTER</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.subMode<sp /><sp />=<sp /><ref kindref="member" refid="group__group__scb__spi__enums_1gga1410916a9c76b0d86eb196b8e9ed547fa62fab87ba422296db9c490c3b74830ab">CY_SCB_SPI_MOTOROLA</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.sclkMode<sp />=<sp /><ref kindref="member" refid="group__group__scb__spi__enums_1ggab34eae51343cebfec7c447a573cdf0baac7839625f0402b7b9685f3fc2c8a2305">CY_SCB_SPI_CPHA0_CPOL0</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.oversample<sp />=<sp />10UL,</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.rxDataWidth<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />8UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.txDataWidth<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />8UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableMsbFirst<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableInputFilter<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableFreeRunSclk<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableMisoLateSample<sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableTransferSeperation<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.ssPolarity<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /><ref kindref="member" refid="group__group__scb__spi__enums_1ggac1d52a37938101b62b908fb4263d98a2ab36d0ae32e47bb37ec614d9bc58b7198">CY_SCB_SPI_ACTIVE_LOW</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.enableWakeFromSleep<sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.rxFifoTriggerLevel<sp /><sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.rxFifoIntEnableMask<sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.txFifoTriggerLevel<sp /><sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.txFifoIntEnableMask<sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.masterSlaveIntEnableMask<sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Configure<sp />SPI<sp />to<sp />operate<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">(void)<sp /><ref kindref="member" refid="group__group__scb__spi__general__functions_1gabe68169c810119b93e1164127663033c">Cy_SCB_SPI_Init</ref>(SCB1,<sp />&amp;spiConfig,<sp />&amp;spiContext);</highlight></codeline>
</programlisting></para>

<para><bold>Assign and Configure Pins</bold></para>
<para>Only dedicated SCB pins can be used for SPI operation. The HSIOM register must be configured to connect dedicated SCB SPI pins to the SCB block. Also, the SPI output pins must be configured in Strong Drive Input Off mode and SPI input pins in Digital High-Z.</para><para><programlisting><codeline><highlight class="comment">/*<sp />Assign<sp />pins<sp />for<sp />SPI<sp />on<sp />SCB1:<sp />P10[0],<sp />P10[1],<sp />P10[2]<sp />and<sp />P10[3]<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />SPI_PORT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />P10_0_PORT</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />SPI_MISO_NUM<sp /><sp /><sp /><sp />P10_0_NUM</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />SPI_MOSI_NUM<sp /><sp /><sp /><sp />P10_1_NUM</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />SPI_SCLK_NUM<sp /><sp /><sp /><sp />P10_2_NUM</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />SPI_SS_NUM<sp /><sp /><sp /><sp /><sp /><sp />P10_3_NUM</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Connect<sp />SCB1<sp />SPI<sp />function<sp />to<sp />pins<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__gpio__functions__init_1ga83a06264feed0e1042671a74339ea155">Cy_GPIO_SetHSIOM</ref>(SPI_PORT,<sp />SPI_MISO_NUM,<sp />P10_1_SCB1_SPI_MISO);</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__gpio__functions__init_1ga83a06264feed0e1042671a74339ea155">Cy_GPIO_SetHSIOM</ref>(SPI_PORT,<sp />SPI_MOSI_NUM,<sp />P10_0_SCB1_SPI_MOSI);</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__gpio__functions__init_1ga83a06264feed0e1042671a74339ea155">Cy_GPIO_SetHSIOM</ref>(SPI_PORT,<sp />SPI_SCLK_NUM,<sp />P10_2_SCB1_SPI_CLK);</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__gpio__functions__init_1ga83a06264feed0e1042671a74339ea155">Cy_GPIO_SetHSIOM</ref>(SPI_PORT,<sp />SPI_SS_NUM,<sp /><sp /><sp />P10_3_SCB1_SPI_SELECT0);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#if<sp />(USE_SPI_SLAVE)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />SCB1<sp />pins<sp />for<sp />SPI<sp />Slave<sp />operation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__gpio__functions__gpio_1ga97e64dc8c45e7cd73e3012100d03b1fd">Cy_GPIO_SetDrivemode</ref>(SPI_PORT,<sp />SPI_MISO_NUM,<sp /><ref kindref="member" refid="group__group__gpio__drive_modes_1gacebd8bea6222d742bdfbfd86dabab940">CY_GPIO_DM_STRONG_IN_OFF</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__gpio__functions__gpio_1ga97e64dc8c45e7cd73e3012100d03b1fd">Cy_GPIO_SetDrivemode</ref>(SPI_PORT,<sp />SPI_MOSI_NUM,<sp /><ref kindref="member" refid="group__group__gpio__drive_modes_1gaf2fe5dc00ba1770b37e620a01169485c">CY_GPIO_DM_HIGHZ</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__gpio__functions__gpio_1ga97e64dc8c45e7cd73e3012100d03b1fd">Cy_GPIO_SetDrivemode</ref>(SPI_PORT,<sp />SPI_SCLK_NUM,<sp /><ref kindref="member" refid="group__group__gpio__drive_modes_1gaf2fe5dc00ba1770b37e620a01169485c">CY_GPIO_DM_HIGHZ</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__gpio__functions__gpio_1ga97e64dc8c45e7cd73e3012100d03b1fd">Cy_GPIO_SetDrivemode</ref>(SPI_PORT,<sp />SPI_SS_NUM,<sp /><sp /><sp /><ref kindref="member" refid="group__group__gpio__drive_modes_1gaf2fe5dc00ba1770b37e620a01169485c">CY_GPIO_DM_HIGHZ</ref>);</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#else<sp /></highlight><highlight class="comment">/*<sp />(USE_SPI_SLAVE)<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />SCB1<sp />pins<sp />for<sp />SPI<sp />Master<sp />operation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__gpio__functions__gpio_1ga97e64dc8c45e7cd73e3012100d03b1fd">Cy_GPIO_SetDrivemode</ref>(SPI_PORT,<sp />SPI_MISO_NUM,<sp /><ref kindref="member" refid="group__group__gpio__drive_modes_1gaf2fe5dc00ba1770b37e620a01169485c">CY_GPIO_DM_HIGHZ</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__gpio__functions__gpio_1ga97e64dc8c45e7cd73e3012100d03b1fd">Cy_GPIO_SetDrivemode</ref>(SPI_PORT,<sp />SPI_MOSI_NUM,<sp /><ref kindref="member" refid="group__group__gpio__drive_modes_1gacebd8bea6222d742bdfbfd86dabab940">CY_GPIO_DM_STRONG_IN_OFF</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__gpio__functions__gpio_1ga97e64dc8c45e7cd73e3012100d03b1fd">Cy_GPIO_SetDrivemode</ref>(SPI_PORT,<sp />SPI_SCLK_NUM,<sp /><ref kindref="member" refid="group__group__gpio__drive_modes_1gacebd8bea6222d742bdfbfd86dabab940">CY_GPIO_DM_STRONG_IN_OFF</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__gpio__functions__gpio_1ga97e64dc8c45e7cd73e3012100d03b1fd">Cy_GPIO_SetDrivemode</ref>(SPI_PORT,<sp />SPI_SS_NUM,<sp /><sp /><sp /><ref kindref="member" refid="group__group__gpio__drive_modes_1gacebd8bea6222d742bdfbfd86dabab940">CY_GPIO_DM_STRONG_IN_OFF</ref>);</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif</highlight></codeline>
</programlisting></para>

<para><bold>Assign Clock Divider</bold></para>
<para>A clock source must be connected to the SCB block to oversample input and output signals, in this document this clock will be referred as clk_scb. You must use one of the 8-bit or 16-bit dividers. Use the <ref kindref="compound" refid="group__group__sysclk">SysClk (System Clock)</ref> driver API to do this.</para><para><programlisting><codeline><highlight class="comment">/*<sp />Assign<sp />divider<sp />type<sp />and<sp />number<sp />for<sp />SPI<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />SPI_CLK_DIV_TYPE<sp /><sp /><sp /><sp />(CY_SYSCLK_DIV_8_BIT)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />SPI_CLK_DIV_NUM<sp /><sp /><sp /><sp /><sp />(0U)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Connect<sp />assigned<sp />divider<sp />to<sp />be<sp />a<sp />clock<sp />source<sp />for<sp />SPI<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1gacb66324e3191006f6d1cee8b29238fb2">Cy_SysClk_PeriphAssignDivider</ref>(PCLK_SCB1_CLOCK,<sp />SPI_CLK_DIV_TYPE,<sp />SPI_CLK_DIV_NUM);</highlight></codeline>
</programlisting></para>

<para><bold>Configure Data Rate</bold></para>
<para>To get the SPI slave to operate with the desired data rate, the clk_scb must be fast enough to provide sufficient oversampling. Use the <ref kindref="compound" refid="group__group__sysclk">SysClk (System Clock)</ref> driver API to do that.</para><para><programlisting><codeline><highlight class="comment">/*<sp />SPI<sp />data<sp />rate<sp />is<sp />defined<sp />by<sp />the<sp />SPI<sp />master<sp />because<sp />it<sp />drives<sp />SCLK.</highlight></codeline>
<codeline><highlight class="comment">*<sp />This<sp />clk_scb<sp />enables<sp />SPI<sp />slave<sp />operate<sp />up<sp />to<sp />maximum<sp />supported<sp />data<sp />rate.</highlight></codeline>
<codeline><highlight class="comment">*<sp />For<sp />clk_peri<sp />=<sp />50<sp />MHz,<sp />select<sp />divider<sp />value<sp />1<sp />and<sp />get<sp />clk_scb<sp />=<sp />(50<sp />MHz<sp />/<sp />1)<sp />=<sp />50<sp />MHz.</highlight></codeline>
<codeline><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1gac67931844e6ec06b5ff88f4f3119e127">Cy_SysClk_PeriphSetDivider</ref><sp /><sp /><sp />(SPI_CLK_DIV_TYPE,<sp />SPI_CLK_DIV_NUMBER,<sp />0UL);</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1ga8c626f11b583d8296516bbcf4a22f98e">Cy_SysClk_PeriphEnableDivider</ref>(SPI_CLK_DIV_TYPE,<sp />SPI_CLK_DIV_NUMBER);</highlight></codeline>
</programlisting> To get the SPI master to operate with the desired data rate, multiply the oversample factor by the desired data rate to determine the required frequency for clk_scb. Use the <ref kindref="compound" refid="group__group__sysclk">SysClk (System Clock)</ref> driver API to configure clk_scb frequency. Set the <emphasis><bold>oversample parameter in configuration structure</bold></emphasis> to define number of SCB clocks in one SCLK period. When this value is even, the first and second phases of the SCLK period are the same. Otherwise, the first phase is one SCB clock cycle longer than the second phase. The level of the first phase of the clock period depends on CPOL settings: 0 - low level and 1 - high level.</para><para><programlisting><codeline><highlight class="comment">/*<sp />SPI<sp />master<sp />desired<sp />data<sp />rate<sp />is<sp />1<sp />Mbps.</highlight></codeline>
<codeline><highlight class="comment">*<sp />The<sp />SPI<sp />master<sp />data<sp />rate<sp />=<sp />(clk_scb<sp />/<sp />Oversample).</highlight></codeline>
<codeline><highlight class="comment">*<sp />For<sp />clk_peri<sp />=<sp />50<sp />MHz,<sp />select<sp />divider<sp />value<sp />5<sp />and<sp />get<sp />SCB<sp />clock<sp />=<sp />(50<sp />MHz<sp />/<sp />5)<sp />=<sp />10<sp />MHz.</highlight></codeline>
<codeline><highlight class="comment">*<sp />Select<sp />Oversample<sp />=<sp />10.<sp />These<sp />setting<sp />results<sp />SPI<sp />data<sp />rate<sp />=<sp />10<sp />MHz<sp />/<sp />10<sp />=<sp />1<sp />Mbps.</highlight></codeline>
<codeline><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1gac67931844e6ec06b5ff88f4f3119e127">Cy_SysClk_PeriphSetDivider</ref><sp /><sp /><sp />(SPI_CLK_DIV_TYPE,<sp />SPI_CLK_DIV_NUMBER,<sp />4UL);</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1ga8c626f11b583d8296516bbcf4a22f98e">Cy_SysClk_PeriphEnableDivider</ref>(SPI_CLK_DIV_TYPE,<sp />SPI_CLK_DIV_NUMBER);</highlight></codeline>
</programlisting> <bold>Refer to the technical reference manual (TRM) section SPI sub-section Oversampling and Bit Rate to get information about how to configure SPI to run with desired data rate</bold>.</para>

<para><bold>Configure Interrupt</bold></para>
<para>The interrupt is optional for the SPI operation. To configure the interrupt, the <ref kindref="member" refid="group__group__scb__spi__interrupt__functions_1ga0adeb497479d79c9ecea8169cfaff114">Cy_SCB_SPI_Interrupt</ref> function must be called in the interrupt handler for the selected SCB instance. Also, this interrupt must be enabled in the NVIC. The interrupt must be configured when <ref kindref="member" refid="group__group__scb__spi_1group_scb_spi_hl">High-Level API</ref> will be used.</para><para><programlisting><codeline><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />SPI_Isr(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__scb__spi__interrupt__functions_1ga0adeb497479d79c9ecea8169cfaff114">Cy_SCB_SPI_Interrupt</ref>(SCB1,<sp />&amp;spiContext);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="comment">/*<sp />Assign<sp />SPI<sp />interrupt<sp />number<sp />and<sp />priority<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />SPI_INTR_NUM<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((IRQn_Type)<sp />scb_1_interrupt_IRQn)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />SPI_INTR_PRIORITY<sp /><sp /><sp />(7U)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Populate<sp />configuration<sp />structure<sp />(code<sp />specific<sp />for<sp />CM4)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__sysint__t">cy_stc_sysint_t</ref><sp />spiIntrConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__sysint__t_1a6da08d81da65a7f93d3e4c46a4b8d950">intrSrc</ref><sp /><sp /><sp /><sp /><sp /><sp />=<sp />SPI_INTR_NUM,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.intrPriority<sp />=<sp />SPI_INTR_PRIORITY,</highlight></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Hook<sp />interrupt<sp />service<sp />routine<sp />and<sp />enable<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">(void)<sp /><ref kindref="member" refid="group__group__sysint__functions_1gab2ff6820a898e9af3f780000054eea5d">Cy_SysInt_Init</ref>(&amp;spiIntrConfig,<sp />&amp;SPI_Isr);</highlight></codeline>
<codeline><highlight class="normal">NVIC_EnableIRQ(SPI_INTR_NUM);</highlight></codeline>
</programlisting></para>

<para><bold>Enable SPI</bold></para>
<para>Finally, enable the SPI operation by calling <ref kindref="member" refid="group__group__scb__spi__general__functions_1ga7e5d7cb17044cdd8ab1543e038bf89a8">Cy_SCB_SPI_Enable</ref>. For the slave, this means that SPI device starts responding to the transfers. For the master, it is ready to execute transfers.</para><para><programlisting><codeline><highlight class="comment">/*<sp />Enable<sp />SPI<sp />to<sp />operate<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__scb__spi__general__functions_1ga7e5d7cb17044cdd8ab1543e038bf89a8">Cy_SCB_SPI_Enable</ref>(SCB1);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Enable<sp />global<sp />interrupts<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">__enable_irq();</highlight></codeline>
</programlisting></para>


<para><heading level="1">Common Use Cases</heading></para>
<para>The SPI API is the same for the master and slave mode operation and is divided into two categories: <ref kindref="compound" refid="group__group__scb__spi__low__level__functions">Low-Level</ref> and <ref kindref="compound" refid="group__group__scb__spi__high__level__functions">High-Level</ref>. <linebreak />
<emphasis>Do not mix <bold>High-Level</bold> and <bold>Low-Level</bold> API because a Low-Level API can adversely affect the operation of a High-Level API.</emphasis></para>
<para><bold>Low-Level API</bold></para>
<para>The <ref kindref="compound" refid="group__group__scb__spi__low__level__functions">Low-Level</ref> functions allow interacting directly with the hardware and do not use <ref kindref="member" refid="group__group__scb__spi__interrupt__functions_1ga0adeb497479d79c9ecea8169cfaff114">Cy_SCB_SPI_Interrupt</ref>. These functions do not require context for operation. Thus, NULL can be passed for context parameter in <ref kindref="member" refid="group__group__scb__spi__general__functions_1gabe68169c810119b93e1164127663033c">Cy_SCB_SPI_Init</ref> and <ref kindref="member" refid="group__group__scb__spi__general__functions_1ga01fcd87713fe370d94828563ff1e86b8">Cy_SCB_SPI_Disable</ref> instead of a pointer to the context structure.</para><para><itemizedlist>
<listitem><para>To write data into the TX FIFO, use one of the provided functions: <ref kindref="member" refid="group__group__scb__spi__low__level__functions_1ga6b613c5544c0595763e30d83da125a4d">Cy_SCB_SPI_Write</ref>, <ref kindref="member" refid="group__group__scb__spi__low__level__functions_1gad5415bd46d159b57f08fa0eb375a133e">Cy_SCB_SPI_WriteArray</ref> or <ref kindref="member" refid="group__group__scb__spi__low__level__functions_1ga6899c2b1dd9f868a7fb625b03a7ee594">Cy_SCB_SPI_WriteArrayBlocking</ref>. Note that in the master mode, putting data into the TX FIFO starts a transfer. Due to the nature of SPI, the received data is put into the RX FIFO.</para></listitem><listitem><para>To read data from the RX FIFO, use one of the provided functions: <ref kindref="member" refid="group__group__scb__spi__low__level__functions_1ga169c313a3508261fa76e6b6600cce726">Cy_SCB_SPI_Read</ref> or <ref kindref="member" refid="group__group__scb__spi__low__level__functions_1gaecc7c7a8d0ba840fa5d65e5076cb9d84">Cy_SCB_SPI_ReadArray</ref>. Again due to the nature of SPI these functions do not start a transfer on the bus, they only read data out of the RX FIFO that has already been received.</para></listitem><listitem><para>The statuses can be polled using: <ref kindref="member" refid="group__group__scb__spi__low__level__functions_1ga50acb3879906a729e5821fcc87d4f017">Cy_SCB_SPI_GetRxFifoStatus</ref>, <ref kindref="member" refid="group__group__scb__spi__low__level__functions_1ga987fdbe86c1fbfbadfa51cdf82f84632">Cy_SCB_SPI_GetTxFifoStatus</ref> and <ref kindref="member" refid="group__group__scb__spi__low__level__functions_1gac9e9a4b77a8db35ccbda974e7f9d9d23">Cy_SCB_SPI_GetSlaveMasterStatus</ref>. <emphasis>The statuses are <bold>W1C (Write 1 to Clear)</bold> and after a status is set, it must be cleared.</emphasis> Note that there are statuses evaluated as level. These statuses remain set until an event is true. Therefore, after the clear operation, the status is cleared but then it is restored (if the event is still true). Also, the following functions can be used for polling as well <ref kindref="member" refid="group__group__scb__spi__general__functions_1ga4241f6166816159f7365220834a5e0d0">Cy_SCB_SPI_IsBusBusy</ref>, <ref kindref="member" refid="group__group__scb__spi__low__level__functions_1ga399842a2931b7c6cd85446a72cc2f81b">Cy_SCB_SPI_IsTxComplete</ref>, <ref kindref="member" refid="group__group__scb__spi__low__level__functions_1gaea6c37058e015b59c0e307d0d0e77ad0">Cy_SCB_SPI_GetNumInRxFifo</ref> and <ref kindref="member" refid="group__group__scb__spi__low__level__functions_1gad9be16f0ae646a85e9fffe9731cb4896">Cy_SCB_SPI_GetNumInTxFifo</ref>.</para></listitem></itemizedlist>
</para><para><programlisting><codeline><highlight class="normal">uint8_t<sp />txBuffer[BUFFER_SIZE];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Initialize<sp />txBuffer<sp />with<sp />command<sp />to<sp />transfer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">txBuffer[0]<sp />=<sp />CMD_START_TRANSFER;</highlight></codeline>
<codeline><highlight class="normal">txBuffer[1]<sp />=<sp />0x00U;</highlight></codeline>
<codeline><highlight class="normal">txBuffer[2]<sp />=<sp />0x01U;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Master:<sp />start<sp />a<sp />transfer.<sp />Slave:<sp />prepare<sp />for<sp />a<sp />transfer.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__scb__spi__low__level__functions_1ga6899c2b1dd9f868a7fb625b03a7ee594">Cy_SCB_SPI_WriteArrayBlocking</ref>(SCB1,<sp />txBuffer,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(txBuffer));</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Blocking<sp />wait<sp />for<sp />transfer<sp />completion<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />(!<ref kindref="member" refid="group__group__scb__spi__low__level__functions_1ga399842a2931b7c6cd85446a72cc2f81b">Cy_SCB_SPI_IsTxComplete</ref>(SCB1))</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Handle<sp />results<sp />of<sp />a<sp />transfer<sp />*/</highlight><highlight class="normal" /></codeline>
</programlisting></para>

<para><bold>High-Level API</bold></para>
<para>The <ref kindref="compound" refid="group__group__scb__spi__high__level__functions">High-Level</ref> API use <ref kindref="member" refid="group__group__scb__spi__interrupt__functions_1ga0adeb497479d79c9ecea8169cfaff114">Cy_SCB_SPI_Interrupt</ref> to execute the transfer. Call <ref kindref="member" refid="group__group__scb__spi__high__level__functions_1ga6fdbb98ef7faddc5025fab510fb1617e">Cy_SCB_SPI_Transfer</ref> to start communication: for master mode calling this function starts a transaction with the slave. For slave mode the read and write buffers are prepared for the communication with the master. After a transfer is started, the <ref kindref="member" refid="group__group__scb__spi__interrupt__functions_1ga0adeb497479d79c9ecea8169cfaff114">Cy_SCB_SPI_Interrupt</ref> handles the transfer until its completion. Therefore, the <ref kindref="member" refid="group__group__scb__spi__interrupt__functions_1ga0adeb497479d79c9ecea8169cfaff114">Cy_SCB_SPI_Interrupt</ref> function must be called inside the user interrupt handler to make the High-Level API work. To monitor the status of the transfer operation, use <ref kindref="member" refid="group__group__scb__spi__high__level__functions_1ga95069817e25be749ae989e5d7131f8d0">Cy_SCB_SPI_GetTransferStatus</ref>. Alternatively, use <ref kindref="member" refid="group__group__scb__spi__interrupt__functions_1ga5594391e0d6a0b020355761826de2e78">Cy_SCB_SPI_RegisterCallback</ref> to register a callback function to be notified about <ref kindref="compound" refid="group__group__scb__spi__macros__callback__events">SPI Callback Events</ref>.</para><para><programlisting><codeline><highlight class="normal">uint8_t<sp />rxBuffer[BUFFER_SIZE];</highlight></codeline>
<codeline><highlight class="normal">uint8_t<sp />txBuffer[BUFFER_SIZE];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Initialize<sp />txBuffer<sp />with<sp />command<sp />to<sp />transfer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">txBuffer[0]<sp />=<sp />CMD_START_TRANSFER;</highlight></codeline>
<codeline><highlight class="normal">txBuffer[1]<sp />=<sp />0x00U;</highlight></codeline>
<codeline><highlight class="normal">txBuffer[2]<sp />=<sp />0x01U;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Master:<sp />start<sp />a<sp />transfer.<sp />Slave:<sp />prepare<sp />for<sp />a<sp />transfer.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">(void)<sp /><ref kindref="member" refid="group__group__scb__spi__high__level__functions_1ga6fdbb98ef7faddc5025fab510fb1617e">Cy_SCB_SPI_Transfer</ref>(SCB1,<sp />txBuffer,<sp />rxBuffer,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(txBuffer),<sp />&amp;spiContext);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Blocking<sp />wait<sp />for<sp />transfer<sp />completion<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />(0UL<sp />!=<sp />(<ref kindref="member" refid="group__group__scb__spi__macros__xfer__status_1gab024f7d6ed7cbaa36c80c904a6179de7">CY_SCB_SPI_TRANSFER_ACTIVE</ref><sp />&amp;<sp /><ref kindref="member" refid="group__group__scb__spi__high__level__functions_1ga95069817e25be749ae989e5d7131f8d0">Cy_SCB_SPI_GetTransferStatus</ref>(SCB1,<sp />&amp;spiContext)))</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Handle<sp />results<sp />of<sp />a<sp />transfer<sp />*/</highlight><highlight class="normal" /></codeline>
</programlisting></para>


<para><heading level="1">DMA Trigger</heading></para>
<para>The SCB provides TX and RX output trigger signals that can be routed to the DMA controller inputs. These signals are assigned based on the data availability in the TX and RX FIFOs appropriately.</para><para><itemizedlist>
<listitem><para>The RX trigger signal is active while the number of data elements in the RX FIFO is greater than the value of RX FIFO level. Use function <ref kindref="member" refid="group__group__scb__common__functions_1ga64d034531ea5eb2695ed018d6a75da68">Cy_SCB_SetRxFifoLevel</ref> or set configuration structure rxFifoTriggerLevel parameter to configure RX FIFO level value. <linebreak />
 <emphasis>For example, the RX FIFO has 8 data elements and the RX FIFO level is 0. The RX trigger signal is active until DMA reads all data from the RX FIFO.</emphasis></para></listitem><listitem><para>The TX trigger signal is active while the number of data elements in the TX FIFO is less than the value of TX FIFO level. Use function <ref kindref="member" refid="group__group__scb__common__functions_1ga36285e337c94df91a4ebe5b1ee0fd43d">Cy_SCB_SetTxFifoLevel</ref> or set configuration structure txFifoTriggerLevel parameter to configure TX FIFO level value. <linebreak />
 <emphasis>For example, the TX FIFO has 0 data elements (empty) and the TX FIFO level is 7. The TX trigger signal is active until DMA loads TX FIFO with 8 data elements (note that after the first TX load operation, the data element goes to the shift register and TX FIFO is empty).</emphasis></para></listitem></itemizedlist>
</para><para>To route SCB TX or RX trigger signals to the DMA controller, use <ref kindref="compound" refid="group__group__trigmux">TrigMux (Trigger Multiplexer)</ref> driver API.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;To properly handle DMA level request signal activation and de-activation from the SCB peripheral block the DMA Descriptor typically must be configured to re-trigger after 16 Clk_Slow cycles.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><heading level="1">Low Power Support</heading></para>
<para>The SPI driver provides callback functions to handle power mode transitions. The callback <ref kindref="member" refid="group__group__scb__spi__low__power__functions_1gabf413c42a9ba8a20c38f2491ae2e36c0">Cy_SCB_SPI_DeepSleepCallback</ref> must be called during execution of <ref kindref="member" refid="group__group__syspm__functions__power_1ga5150c28fe4d2626720c1fbf74b3111ca">Cy_SysPm_CpuEnterDeepSleep</ref>; <ref kindref="member" refid="group__group__scb__spi__low__power__functions_1ga1bf16639bec6ac8209621227bd5ac0e3">Cy_SCB_SPI_HibernateCallback</ref> must be called during execution of <ref kindref="member" refid="group__group__syspm__functions__power_1gae97647a28c370674ba57d451d21d1c51">Cy_SysPm_SystemEnterHibernate</ref>. To trigger the callback execution, the callback must be registered before calling the power mode transition function. Refer to <ref kindref="compound" refid="group__group__syspm">SysPm (System Power Management)</ref> driver for more information about power mode transitions and callback registration.</para><para>The SPI master is disabled during Deep Sleep and Hibernate and stops driving the output pins. The state of the SPI master output pins SCLK, SS, and MOSI is High-Z, which can cause unexpected behavior of the SPI Slave due to possible glitches on these lines. These pins must keep the inactive level (the same state when SPI master is enabled and does not transfer data) before entering Deep Sleep or Hibernate mode. To do that, write the GPIO data register of each pin to the inactive level for each output pin. Then configure High-Speed Input Output Multiplexer (HSIOM) of each pin to be controlled by the GPIO (use <ref kindref="compound" refid="group__group__gpio">GPIO (General Purpose Input Output)</ref> driver API). After after exiting Deep Sleep mode the SPI master must be enabled and the pins configuration restored to return the SPI master control of the pins (after exiting Hibernate mode, the system initialization code does the same). Copy either or both <ref kindref="member" refid="group__group__scb__spi__low__power__functions_1gabf413c42a9ba8a20c38f2491ae2e36c0">Cy_SCB_SPI_DeepSleepCallback</ref> and <ref kindref="member" refid="group__group__scb__spi__low__power__functions_1ga1bf16639bec6ac8209621227bd5ac0e3">Cy_SCB_SPI_HibernateCallback</ref> as appropriate, and make the changes described above inside the function. Alternately, external pull-up or pull-down resistors can be connected to the appropriate SPI lines to keep them inactive during Deep-Sleep or Hibernate.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Only applicable for &lt;b&gt;rev-08 of the CY8CKIT-062-BLE&lt;/b&gt;. For proper operation, when the SPI slave is configured to be a wakeup source from Deep Sleep mode, the &lt;a href="group__group__scb__spi__low__power__functions.html#group__group__scb__spi__low__power__functions_1gabf413c42a9ba8a20c38f2491ae2e36c0"&gt;Cy_SCB_SPI_DeepSleepCallback&lt;/a&gt; must be copied and modified. Refer to the function description to get the details. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>